<?php

if (!class_exists('ARM_subsctriptions')) {

    class ARM_subsctriptions{
        
        function __construct(){
            global $wpdb, $ARMember, $arm_slugs;

            add_action('wp_ajax_get_activity_data',array($this, 'arm_fetch_activity_data'));
            add_action('wp_ajax_get_subscription_data',array($this, 'arm_fetch_subscription_data'));
            add_action('wp_ajax_transaction_activity_ajax_action',array($this, 'arm_delete_transaction_data'));
            add_action('wp_ajax_arm_change_bank_transfer_status', array($this, 'arm_change_bank_transfer_status'));
            add_action('wp_ajax_arm_invoice_detail', array($this, 'arm_invoice_detail'));
            add_action('wp_ajax_arm_cancel_subscription_ajax_action',array($this, 'arm_cancel_subscription_data'));
            add_action('wp_ajax_arm_refund_subscription_ajax_action',array($this, 'arm_refund_subscription_action')); 
            add_action('wp_ajax_arm_add_new_subscriptions',array($this,'arm_add_new_subscriptions'));
            add_action('wp_ajax_get_user_all_transaction_details_for_grid',array($this,'get_user_all_transaction_details_for_grid'));      
            add_action('wp_ajax_arm_activation_subscription_plan',array($this,'arm_activation_subscription_plan'),10,2);     
        }
        function arm_activation_subscription_plan()
        {
            global $wp,$wpdb,$ARMember,$arm_global_settings, $arm_subscription_plans, $arm_payment_gateways, $global_currency_sym ,$arm_capabilities_global,$arm_members_class;

            $response = array('type'=>'error','msg'=>__('Something went wrong','ARMember'));
            $ARMember->arm_check_user_cap($arm_capabilities_global['arm_manage_subscriptions'], '1');

            $activity_id = $_POST['arm_activity'];
            $sql_act = 'SELECT `arm_user_id`,`arm_item_id` FROM '.$ARMember->tbl_arm_activity.' WHERE arm_activity_id='.$activity_id;
            
            $get_result_sql = $wpdb->get_row($sql_act,ARRAY_A);
            $user_id = $get_result_sql['arm_user_id'];
            $plan_id = $get_result_sql['arm_item_id'];

            $post_data=array('arm_action'=>'status','user_id'=>$user_id,'plan_id'=>$plan_id);

            $is_activated = $arm_members_class->arm_user_plan_action($post_data,true);

            if($is_activated['type'] == 'success')
            {
                $response = array('type'=>'success','msg'=>$is_activated['msg']);
            }
            else
            {
                $response = array('type'=>'error','msg'=>$is_activated['msg']);
            }
            echo json_encode($response);
            die;
        }
        function get_user_all_transaction_details_for_grid(){
            global $wp,$wpdb,$ARMember,$arm_global_settings, $arm_subscription_plans, $arm_payment_gateways, $arm_transaction,$global_currency_sym ,$arm_capabilities_global;

            $ARMember->arm_check_user_cap($arm_capabilities_global['arm_manage_subscriptions'], '1');

            $arm_invoice_tax_feature = get_option('arm_is_invoice_tax_feature', 0);

            $arm_activity_id = $_POST['activity_id'];

            $get_result_sql = 'SELECT act.arm_activity_id,act.arm_user_id,am.arm_user_login,act.arm_content,act.arm_item_id,act.arm_date_recorded FROM '.$ARMember->tbl_arm_activity.' act LEFT JOIN '.$ARMember->tbl_arm_members.' am ON act.arm_user_id = am.arm_user_id WHERE act.arm_activity_id ='.$arm_activity_id;
            $response_result = $wpdb->get_row($get_result_sql);
            
            $return='';
            
            if(!empty($response_result))
            {
                $rc = (object) $response_result;
               
                $get_activity_data = maybe_unserialize($rc->arm_content);
                $grace_period_data = $plan_detail = $membership_start = '';
                $user_id = $rc->arm_user_id;
                $date_format = $arm_global_settings->arm_get_wp_date_format();
                $user_plan_detail = get_user_meta($user_id, 'arm_user_plan_'.$rc->arm_item_id, true);
                $start_plan_date = $get_activity_data['start'];
                $plan_status = $this->get_return_status_data($user_id,$rc->arm_item_id,$user_plan_detail,$start_plan_date);
                $canceled_date = !empty($plan_status['canceled_date']) ? $plan_status['canceled_date'] : '';
                $transaction_started_date = date('Y-m-d 00:00:00', $start_plan_date);
                
                if($get_activity_data['gateway'] !='manual')
                {
                    $transaction_started_date =date('Y-m-d H:i:s', ( $start_plan_date - 120));
                }
                if(!empty($canceled_date))
                {
                    $get_last_transaction_sql = "SELECT * FROM ".$ARMember->tbl_arm_payment_log." WHERE arm_user_id=".$user_id." AND arm_plan_id=".$rc->arm_item_id." AND arm_created_date BETWEEN '".$transaction_started_date."' AND '".$canceled_date."'  ORDER BY arm_log_id DESC";
                }
                else
                {
                    $get_last_transaction_sql = "SELECT * FROM ".$ARMember->tbl_arm_payment_log." WHERE arm_user_id=".$user_id." AND arm_plan_id=".$rc->arm_item_id." AND arm_created_date >= '".$transaction_started_date."' ORDER BY arm_log_id DESC";
                }
                $return .= '<div class="arm_child_row_div"><table class="arm_user_child__transaction_table " cellspacing="1" >';
                $return .= '<tr class="arm_child_transaction_row">';
                $return .= '<th>' . __('Invoice ID', 'ARMember') . '</th>';
                $return .= '<th>' . __('Transaction ID', 'ARMember') . '</th>';
                $return .= '<th>' . __('Subscription ID', 'ARMember') . '</th>';
                $return .= '<th>' . __('Payment Gateway', 'ARMember') . '</th>';
                $return .= '<th>' . __('Amount', 'ARMember') . '</th>';
                $return .= '<th>' . __('Status', 'ARMember') . '</th>';
                $return .= '<th>' . __('Transaction Date', 'ARMember') . '</th>';
                $return .= '</tr>';
                $response_transaction_result = $wpdb->get_results($get_last_transaction_sql);
                foreach($response_transaction_result as $transactions)
                {
                    $arm_invoice_id = $arm_global_settings->arm_manipulate_invoice_id($transactions->arm_invoice_id);
                    $transactionID = !empty($transactions->arm_transaction_id) ? $transactions->arm_transaction_id : 'manual';
                    $subscription_id = !empty($transactions->arm_token) ? $transactions->arm_token : '-';
                    $arm_transaction_status = $transactions->arm_transaction_status;
                    switch ($arm_transaction_status) {
                        case '0':
                            $arm_transaction_status = 'pending';
                            break;
                        case '1':
                            $arm_transaction_status = 'success';
                            break;
                        case '2':
                            $arm_transaction_status = 'canceled';
                            break;
                        default:
                            $arm_transaction_status = $rc->arm_transaction_status;
                            break;
                    }
                    $return .= '<tr class="arm_child_transaction_row">';
                    if($arm_invoice_tax_feature == 1)
                    {
                        $return .= '<td><a class="armhelptip arm_invoice_detail tipso_style" href="javacript:void(0)" data-log_id='.$transactions->arm_log_id.'>' . $arm_invoice_id. '</a></td>';
                    }
                    else
                    {
                        $return .= '<td>' . $arm_invoice_id. '</td>';
                    }
                    $return .= '<td>' . $transactionID . '</td>';
                    $return .= '<td>' . $subscription_id . '</td>';
                    $return .= '<td>' . $arm_payment_gateways->arm_gateway_name_by_key($transactions->arm_payment_gateway) . '</td>';
                    $return .= '<td>' . $transactions->arm_amount .' '. $transactions->arm_currency . '</td>';
                    $return .= '<td>' . $arm_transaction->arm_get_transaction_status_text($arm_transaction_status) . '</td>';
                    $return .= '<td>' . date_i18n($date_format, strtotime($transactions->arm_payment_date)) . '</td>';
                    $return .= '</tr>';
                }
                $return .= '</table></div>';
            }
            echo $return;
            die;
        }
        function arm_add_new_subscriptions()
        {
            global $wp, $wpdb, $current_user, $arm_errors, $ARMember, $arm_global_settings, $arm_subscription_plans, $arm_payment_gateways, $global_currency_sym,$arm_capabilities_global,$arm_members_class;

            $ARMember->arm_check_user_cap($arm_capabilities_global['arm_manage_subscriptions'], '1');
            $date_format = $arm_global_settings->arm_get_wp_date_format();
            $defaultPlanData = $arm_subscription_plans->arm_default_plan_array();
            $post_data = array();
            if(!empty($_POST))
            {
                $post_data['arm_action'] = 'add';
                $post_data['user_id'] = isset($_POST['arm_user_id_hidden']) ? $_POST['arm_user_id_hidden'] : 0;
                $post_data['arm_user_plan'] = isset($_POST['membership_plan']) ? $_POST['membership_plan'] : 0;
                $membership_type = isset($_POST['plan_type']) ? $_POST['plan_type'] : 0;
                if($membership_type == '1')
                {
                    $post_data['arm_paid_post_request'] = 1;
                    $post_data['arm_user_plan'] = isset($_POST['arm_paid_post_id']) ? $_POST['arm_paid_post_id'] : 0;
                }
                else if($membership_type == '2')
                {
                    $post_data['arm_gift_plan_request'] = 1;
                    $post_data['arm_user_plan'] = isset($_POST['arm_gift_plan_id']) ? $_POST['arm_gift_plan_id'] : 0;
                }
                $post_data['arm_subscription_start_date'] = date_i18n($date_format, strtotime(current_time('mysql')));
                $post_data['user_id'] = isset($_POST['arm_user_id_hidden']) ? intval($_POST['arm_user_id_hidden']) : 0;
                $response = $this->add_plan_action($post_data);
                echo json_encode($response);
                die;
            }
            
        }
        function add_plan_action($post_data=array()) {
            global $wpdb, $ARMember, $arm_member_forms, $arm_manage_communication, $is_multiple_membership_feature, $arm_subscription_plans, $arm_members_class, $arm_global_settings, $arm_capabilities_global, $arm_pay_per_post_feature, $arm_subscription_cancel_msg;
            
            $response = array('type' => 'error', 'msg' => __("Sorry, Something went wrong. Please try again.", 'ARMember'));

            $date_format = $arm_global_settings->arm_get_wp_date_format();
            $defaultPlanData = $arm_subscription_plans->arm_default_plan_array();
            if ($post_data['arm_action'] == 'add') {
                $user_ID = isset($post_data['user_id']) ? intval($post_data['user_id']) : 0;

                do_action('arm_modify_content_on_plan_change', $post_data, $user_ID);

                if (!empty($user_ID)) {
                    if (!isset($post_data['arm_user_plan'])) {
                        $post_data['arm_user_plan'] = 0;
                    } else {
                        if (is_array($post_data['arm_user_plan'])) {
                            foreach ($post_data['arm_user_plan'] as $key => $mpid) {
                                if (empty($mpid)) {
                                    unset($post_data['arm_user_plan'][$key]);
                                } else {
                                    $post_data['arm_subscription_start_' . $mpid] = isset($post_data['arm_subscription_start_date'][$key]) ? $post_data['arm_subscription_start_date'][$key] : '';
                                }
                            }
                            unset($post_data['arm_subscription_start_date']);
                            $post_data['arm_user_plan'] = array_values($post_data['arm_user_plan']);
                        }
                    }
                    unset($post_data['arm_action']);
                    $post_data['action'] = 'update_member';

                    $old_plan_ids = get_user_meta($user_ID, 'arm_user_plan_ids', true);
                    $old_plan_ids = !empty($old_plan_ids) ? $old_plan_ids : array();
                    $old_plan_id = isset($old_plan_ids[0]) ? $old_plan_ids[0] : 0;
                    if (!empty($old_plan_ids)) {
                        foreach ($old_plan_ids as $plan_id) {
                            $field_name = "arm_subscription_expiry_date_" . $plan_id . "_" . $user_ID;
                            if (isset($post_data[$field_name])) {
                                unset($post_data[$field_name]);
                            }
                        }
                    }
                    unset($post_data['user_id']);

                    $arm_old_suscribed_plans = "";


                    $is_paid_post = (!empty($post_data['arm_paid_post_request']) && ($post_data['arm_paid_post_request'] == 1)) ? 1 : 0;
                    $is_gift_plan = (!empty($post_data['arm_gift_plan_request']) && ($post_data['arm_gift_plan_request'] == 1)) ? 1 : 0;

                    if($is_gift_plan || $is_paid_post || $is_multiple_membership_feature->isMultipleMembershipFeature)
                    {
                        if(array_key_exists('arm_user_plan', $post_data))
                        {
                            //Get Old Data Of Subscribed Plans
                            $arm_old_suscribed_plans = get_user_meta($user_ID, 'arm_user_plan_ids', true);

                            $arm_new_subscribed_data = array();
                            array_push($arm_new_subscribed_data, $post_data['arm_user_plan'][0]);
                            
                            foreach($arm_old_suscribed_plans as $value)
                            {
                                if(!in_array($value, $arm_new_subscribed_data))
                                {
                                    array_push($arm_new_subscribed_data, $value);
                                }
                            }


                            $post_data['arm_user_plan'] = $arm_new_subscribed_data;
                        }
                    }

                    do_action('arm_member_update_meta', $user_ID, $post_data);

                    if (isset($post_data['arm_user_plan']) && !empty($post_data['arm_user_plan'])) {
                        if ((is_array($post_data['arm_user_plan']) && $is_multiple_membership_feature->isMultipleMembershipFeature) || ($is_paid_post) || ($is_gift_plan)) {
                            $old_plan_ids = array_intersect($post_data['arm_user_plan'], $old_plan_ids);
                            foreach ($post_data['arm_user_plan'] as $plan_id) {
                                if (!in_array($plan_id, $old_plan_ids)) {
                                    $arm_manage_communication->membership_communication_mail('on_new_subscription', $user_ID, $plan_id);
                                    do_action('arm_after_user_plan_change_by_admin', $user_ID, $plan_id);
                                }
                            }
                        } else {
                            if ($old_plan_id != 0 && $old_plan_id != '') {
                                if ($old_plan_id != $post_data['arm_user_plan']) {
                                    $arm_manage_communication->membership_communication_mail('on_change_subscription_by_admin', $user_ID, $post_data['arm_user_plan']);
                                }
                            } else {
                                $arm_manage_communication->membership_communication_mail('on_new_subscription', $user_ID, $post_data['arm_user_plan']);
                            }
                            do_action('arm_after_user_plan_change_by_admin', $user_ID, $post_data['arm_user_plan']);
                        }
                    }
                    
                    $popup_plan_content = "";
                    if($is_paid_post)
                    {
                        $response = array('type' => 'success', 'msg' => __("Paid Post added successfully.", 'ARMember'), 'content' => $popup_plan_content);
                    }
                    else
                    {
                        $response = array('type' => 'success', 'msg' => __("Plan added successfully.", 'ARMember'), 'content' => $popup_plan_content);
                    }

                    $response = apply_filters('arm_modify_admin_plan_add_response', $response, $user_ID, $popup_plan_content, $post_data);
                }
            }

            if (isset($response['type']) && $response['type'] == 'success' && $user_ID > 0) 
            {
                $userPlanIDs = get_user_meta($user_ID, 'arm_user_plan_ids', true);

        		if(!empty($userPlanIDs))
        		{
        			$userPostIDs = get_user_meta($user_ID, 'arm_user_post_ids', true);
                    foreach($userPlanIDs as $arm_plan_key => $arm_plan_val)
                    {
                        if(isset($userPostIDs[$arm_plan_val]) && in_array($userPostIDs[$arm_plan_val], $userPostIDs))
                        {
                            unset($userPlanIDs[$arm_plan_key]);
                        }
                    }
                    $userPlanIDs = apply_filters('arm_modify_plan_ids_externally',$userPlanIDs,$user_ID);
        		}
                $arm_all_user_plans = $userPlanIDs;
                $arm_future_user_plans = get_user_meta($user_ID, 'arm_user_future_plan_ids', true);
                
                if (!empty($arm_future_user_plans)) {
                    $arm_all_user_plans = array_merge($userPlanIDs, $arm_future_user_plans);
                }
                $arm_user_plans = '';
                $plan_names = array();
                $subscription_effective_from = array();
                if (!empty($arm_all_user_plans) && is_array($arm_all_user_plans)) {
                    foreach ($arm_all_user_plans as $userPlanID) {
                        $plan_data = get_user_meta($user_ID, 'arm_user_plan_' . $userPlanID, true);

                        $userPlanDatameta = !empty($plan_data) ? $plan_data : array();
                        $plan_data = shortcode_atts($defaultPlanData, $userPlanDatameta);
                        $subscription_effective_from_date = $plan_data['arm_subscr_effective'];
                        $change_plan_to = $plan_data['arm_change_plan_to'];

                        $plan_names[$userPlanID] = $arm_subscription_plans->arm_get_plan_name_by_id($userPlanID);
                        $subscription_effective_from[] = array('arm_subscr_effective' => $subscription_effective_from_date, 'arm_change_plan_to' => $change_plan_to);
                    }
                }

                if ($is_multiple_membership_feature->isMultipleMembershipFeature) {
                    $response['multiple_membership'] = '1';

                    $arm_user_plans = '<div class="arm_min_width_120">';
                    $arm_user_plans .= "<a href='javascript:void(0)'  id='arm_show_user_more_plans_" . $user_ID . "' class='arm_show_user_more_plans' data-id='" . $user_ID . "'>";

                    if (!empty($arm_all_user_plans) && is_array($arm_all_user_plans)) {
                        foreach ($arm_all_user_plans as $plan_id) {
                            $plan_color_id = ($plan_id > 10) ? intval($plan_id / 10) : $plan_id;
                            $plan_color_id = ($plan_color_id > 10) ? intval($plan_color_id / 10) : $plan_color_id;
                            $arm_user_plans .= "<span class='armhelptip arm_user_plan_circle arm_user_plan_" . $plan_color_id . "' title='" . stripslashes_deep($plan_names[$plan_id]) . "' >";
                            $plan_name = str_replace('-', '', stripslashes_deep($plan_names[$plan_id]));
                            $words = explode(" ", $plan_name);
                            $plan_name = '';
                            foreach ($words as $w) {
                                $w = preg_replace('/[^A-Za-z0-9\-]/', '', $w);
                                $plan_name .= mb_substr($w, 0, 1, 'utf-8');
                            }
                            $plan_name = strtoupper($plan_name);
                            $arm_user_plans .= substr($plan_name, 0, 2);
                            $arm_user_plans .= "</span>";
                        }
                    }
                    $arm_user_plans .= "</a></div>";
                    $response['membership_plan'] = $arm_user_plans;
                } else {
                    $response['multiple_membership'] = '0';
                    $auser = new WP_User($user_ID);
                    $u_role = array_shift($auser->roles);
                    $user_roles = get_editable_roles();
                    if (!empty($user_roles[$u_role]['name'])) {
                        $arm_user_role = $user_roles[$u_role]['name'];
                    } else {
                        $arm_user_role = '-';
                    }
                    $response['user_role'] = $arm_user_role;

                    $memberTypeText = $arm_members_class->arm_get_member_type_text($user_ID);
                    $response['membership_type'] = $memberTypeText;

                    $plan_name = (!empty($plan_names)) ? implode(',', $plan_names) : '-';
                    $response['membership_plan'] = '<span class="arm_user_plan_' . $user_ID . '">' . stripslashes_deep($plan_name) . '</span>';

                    if (!empty($subscription_effective_from)) {
                        foreach ($subscription_effective_from as $subscription_effective) {
                            $subscr_effective = $subscription_effective['arm_subscr_effective'];
                            $change_plan = $subscription_effective['arm_change_plan_to'];
                            $change_plan_name = $arm_subscription_plans->arm_get_plan_name_by_id($change_plan);
                            if (!empty($change_plan) && $subscr_effective > strtotime($nowDate)) {
                                $response['membership_plan'] .= '<div>' . $change_plan_name . '<br/> (' . __('Effective from', 'ARMember') . ' ' . date_i18n($date_format, $subscr_effective) . ')</div>';
                            }
                        }
                    }
                }
            }
            return $response;
            exit;
        }
        function arm_invoice_detail()
		{
			global $wp, $wpdb, $current_user, $arm_errors, $ARMember, $arm_global_settings, $arm_subscription_plans, $arm_payment_gateways, $global_currency_sym;
			
			$log_id = intval($_POST['log_id']);
			$log_type = sanitize_text_field($_POST['log_type']);
			/* Get Edit Rule Form HTML */
			if (!empty($log_id) && $log_id != 0) {
			?>
				<script type="text/javascript">
					jQuery('#arm_invoice_iframe').on('load', function() {
						var iframeDoc = document.getElementById('arm_invoice_iframe');
					});
					function arm_print_invoice() {
						var iframeDoc = document.getElementById('arm_invoice_iframe');
						iframeDoc.contentWindow.arm_print_invoice_content();
					}
				</script>
				<div class="arm_invoice_detail_popup popup_wrapper arm_invoice_detail_popup_wrapper">
					<div class="popup_wrapper_inner" style="overflow: hidden;">
						<div class="popup_header arm_text_align_center" >
							<span class="popup_close_btn arm_popup_close_btn arm_invoice_detail_close_btn"></span>
							<span class="add_rule_content"><?php _e('Invoice Detail','ARMember' );?></span>
						</div>
						<div class="popup_content_text arm_invoice_detail_popup_text arm_padding_0" id="arm_invoice_detail_popup_text" >
							
							<iframe src="<?php echo ARM_HOME_URL."/?log_id=".$log_id."&log_type=".$log_type."&is_display_invoice=1" ; ?>" id="arm_invoice_iframe" class="arm_width_100_pct" style="height:665px;"></iframe>
						</div>
						<div class="popup_footer arm_text_align_center" style=" padding: 0 0 35px;">
							<button type="button" name="print" onclick="arm_print_invoice();" value="Print" class="armemailaddbtn"><?php _e('Print', 'ARMember'); ?></button>
							<?php 
							$invoice_pdf_icon_html='';
							$invoice_pdf_icon_html=apply_filters('arm_membership_invoice_details_outside',$invoice_pdf_icon_html,$log_id);
							echo $invoice_pdf_icon_html;
							?>
						</div>
					</div>
				</div>
			<?php
			}
			exit;
		}
        function arm_change_bank_transfer_status()
		{
			global $wp, $wpdb, $current_user, $arm_errors, $ARMember, $arm_global_settings, $arm_subscription_plans,$arm_manage_coupons, $arm_debug_payment_log_id, $arm_capabilities_global;
				
            $ARMember->arm_check_user_cap($arm_capabilities_global['arm_manage_subscriptions'], '1');
			
            $log_id = intval($_POST['log_id']);
            $logid_exit_flag = '';
            $new_status = sanitize_text_field($_POST['log_status']);

			$response = array('status' => 'error', 'message' => __('Sorry, Something went wrong. Please try again.', 'ARMember'));
			if (!empty($log_id) && $log_id != 0) {
				$log_data = $wpdb->get_row("SELECT `arm_log_id`, `arm_user_id`, `arm_plan_id`, `arm_payment_cycle` FROM `" . $ARMember->tbl_arm_payment_log . "` WHERE `arm_log_id`='" . $log_id . "'");

                

				do_action('arm_payment_log_entry', 'bank_transfer', 'Change status log data', 'armember', $log_data, $arm_debug_payment_log_id);

				if(!empty($log_data))
				{
					$user_id = $log_data->arm_user_id;
					$plan_id = $log_data->arm_plan_id;
                    $payment_cycle = $log_data->arm_payment_cycle;

                    if ($new_status == '1') {

                    	$plan_payment_mode = 'manual_subscription';
                    	$is_recurring_payment = $arm_subscription_plans->arm_is_recurring_payment_of_user($user_id, $plan_id, $plan_payment_mode);
					
						$nowDate = current_time('mysql');
                        $arm_last_payment_status = $wpdb->get_var("SELECT `arm_transaction_status` FROM `" . $ARMember->tbl_arm_payment_log . "` WHERE `arm_user_id`=".$user_id." AND `arm_plan_id`=".$plan_id." AND `arm_created_date`<='".$nowDate."' ORDER BY `arm_log_id` DESC LIMIT 0,1");
					 	$arm_subscription_plans->arm_update_user_subscription_for_bank_transfer($user_id, $plan_id, 'bank_transfer', $payment_cycle, $arm_last_payment_status);
						$wpdb->update($ARMember->tbl_arm_payment_log, array('arm_transaction_status' => 1), array('arm_log_id' => $log_id));
						
						$userPlanData = get_user_meta($user_id, 'arm_user_plan_'.$plan_id, true);
						$arm_manage_coupons->arm_coupon_apply_to_subscription($user_id, $log_data, 'bank_transfer', $userPlanData);
						
						if($is_recurring_payment)
						{
							do_action('arm_after_recurring_payment_success_outside', $user_id, $plan_id, 'bank_transfer', $plan_payment_mode);
						}
						
                        do_action('arm_after_accept_bank_transfer_payment', $user_id, $plan_id, $log_id);
						$response = array('status' => 'success', 'message' => __('Bank transfer request has been approved.', 'ARMember'));
					} else {
						delete_user_meta($user_id, 'arm_change_plan_to');
						$wpdb->update($ARMember->tbl_arm_payment_log, array('arm_transaction_status' => 2), array('arm_log_id' => $log_id));
                                                do_action('arm_after_decline_bank_transfer_payment',$user_id,$plan_id);
						$response = array('status' => 'success', 'message' => __('Bank transfer request has been cancelled.', 'ARMember'));
					}
				}
			}

			do_action('arm_payment_log_entry', 'bank_transfer', 'Change bank transfer response', 'armember', $response, $arm_debug_payment_log_id);

			if(empty($logid_exit_flag))
			{
				echo json_encode($response);
				exit;
			}
		}
        function arm_delete_transaction_data(){
			global $wpdb, $ARMember, $arm_members_class, $arm_global_settings, $arm_capabilities_global;
			$ARMember->arm_check_user_cap($arm_capabilities_global['arm_manage_subscriptions'], '1');
			if (!isset($_POST))
			{
				return;
			}
			
			$action = sanitize_text_field($_POST['act']);
			$id = intval($_POST['id']);
			if ($action == 'delete')
			{
				if (empty($id))
				{
					$errors[] = __('Invalid action.', 'ARMember');
				}
				else
				{
					if (!current_user_can('arm_manage_subscriptions'))
					{
						$errors[] = __('Sorry, You do not have permission to perform this action.', 'ARMember');
					}
					else {
                        $res_var = $wpdb->delete($ARMember->tbl_arm_payment_log, array('arm_log_id' => $id));

						if ($res_var)
						{
							$message = __('Record deleted successfully.', 'ARMember');
						}
						else
						{
							$errors[] = __('Sorry, Something went wrong. Please try again.', 'ARMember');
						}
					}
				}
			}
			$return_array = $arm_global_settings->handle_return_messages(@$errors, @$message);
			echo json_encode($return_array);
			exit;
		}
        function arm_fetch_activity_data() {
            global $wpdb, $ARMember, $arm_slugs, $arm_members_class, $arm_member_forms, $arm_global_settings, $arm_subscription_plans, $arm_payment_gateways, $is_multiple_membership_feature, $arm_capabilities_global, $arm_pay_per_post_feature,$arm_transaction,$arm_invoice_tax_feature,$arm_gift;
            
            $ARMember->arm_check_user_cap($arm_capabilities_global['arm_manage_subscriptions'], '1');
            $date_format = $arm_global_settings->arm_get_wp_date_format();
            $user_roles = get_editable_roles();
            $nowDate = current_time('mysql');
            $arm_invoice_tax_feature = get_option('arm_is_invoice_tax_feature', 0);

            $global_currency = $arm_payment_gateways->arm_get_global_currency();
			$general_settings = isset($arm_global_settings->global_settings) ? $arm_global_settings->global_settings : array();
			$arm_currency_decimal = isset($general_settings['arm_currency_decimal_digit']) ? $general_settings['arm_currency_decimal_digit'] : 2;

            $response_data = array();

            $filter_ptype = isset($_REQUEST['payment_type']) ? $_REQUEST['payment_type'] : '';
            $filter_search = isset($_REQUEST['sSearch']) ? $_REQUEST['sSearch'] : '';
            $filter_status = isset($_REQUEST['plan_status']) ? $_REQUEST['plan_status'] : '';

            $all_plans = $arm_subscription_plans->arm_get_all_subscription_plans();
            if(!empty($_POST['data']))
            {
                $_REQUEST = $_POST = json_decode(stripslashes_deep($_REQUEST['data']),true);
            }
            $sql = '';
            $filter = '';
            $total_results = 0;
            $response_result = array();
            

            
            $grid_columns = array(
                'ID' => __('ID', 'ARMember'),
                'username' => __('Username', 'ARMember'),
                'date' => __('Start Date', 'ARMember'),
                'arm_payment_cycle' => __('Expire/Next Renewal', 'ARMember'),
                'amount' => __('Amount', 'ARMember'),
                'arm_payment_type' => __('Payment Type', 'ARMember'),
                'transaction' => __('Transaction', 'ARMember'),
                'status' => __('Status', 'ARMember'),
            );

            $displayed_grid_columns = $grid_columns;
            $filter_plans = (!empty($_REQUEST['arm_subs_filter']) && $_REQUEST['arm_subs_filter'] != '') ? $_REQUEST['arm_subs_filter'] : '';
            $filter_status_id = (!empty($_REQUEST['filter_status_id']) && $_REQUEST['filter_status_id'] != 0) ? $_REQUEST['filter_status_id'] : '';
            $filter_gateway = (!empty($_REQUEST['payment_gateway']) && $_REQUEST['payment_gateway'] != '0') ? $_REQUEST['payment_gateway'] : '';
            $filter_plan_type = (!empty($_REQUEST['filter_plan_type']) && $_REQUEST['filter_plan_type'] != '') ? $_REQUEST['filter_plan_type'] : '';
            $filter_tab = (!empty($_REQUEST['selected_tab']) && $_REQUEST['selected_tab'] != '') ? $_REQUEST['selected_tab'] : 'activity';
            
            $grid_columns['action_btn'] = '';            

            $sorting_ord = isset($_REQUEST['sSortDir_0']) ? strtoupper($_REQUEST['sSortDir_0']) : 'DESC';
            $sorting_col = (isset($_REQUEST['iSortCol_0']) && $_REQUEST['iSortCol_0'] > 0) ? $_REQUEST['iSortCol_0'] : '';
            if( isset($_REQUEST['iSortCol_0']) && $_REQUEST['iSortCol_0'] == 0){
                $sorting_ord = 'DESC';
            }
            $offset = isset($_REQUEST['iDisplayStart']) ? $_REQUEST['iDisplayStart'] : 0;
            $limit = isset($_REQUEST['iDisplayLength']) ? $_REQUEST['iDisplayLength'] : 10;
            $phlimit = " LIMIT {$offset},{$limit}";
            
            $response_data = array();
            $grid_columns = array(
                'arm_log_id' => __('ID', 'ARMember'),
                'arm_invoice_id' => __('Order/Invoice ID', 'ARMember'),
                'arm_plan_id' => __('Membership', 'ARMember'),
                'arm_payment_date' => __('Payment Date', 'ARMember'),
                'arm_amount' => __('Amount', 'ARMember'),
                'arm_payment_type' => __('Payment type', 'ARMember'),
                'arm_transaction_status' => __('Payment type', 'ARMember'),
            );
            $data_columns = array();
            $n = 0;
            foreach ($grid_columns as $key => $value) {
                $data_columns[$n]['data'] = $key;
                $n++;
            }
            unset($n);

            $sOrder = "";
            $orderby = $data_columns[(intval($sorting_col))]['data'];

            $order_by_qry = "ORDER BY " . $orderby . " " . $sorting_ord ;
            
            $sql = "SELECT pl.arm_log_id,pl.arm_invoice_id,am.arm_user_id,am.arm_user_login,pl.arm_plan_id,pl.arm_payment_gateway,pl.arm_payment_type,pl.arm_transaction_status,pl.arm_payment_date,pl.arm_is_post_payment,pl.arm_paid_post_id,pl.arm_is_gift_payment,pl.arm_payment_mode,pl.arm_amount,pl.arm_currency FROM ".$ARMember->tbl_arm_payment_log." pl LEFT JOIN ".$ARMember->tbl_arm_members." am ON pl.arm_user_id = am.arm_user_id WHERE 1=1 AND pl.arm_user_id !=0 ";
            $filter ='';
            if (!empty($filter_gateway) && $filter_gateway != '0') {
                $filter .= " AND pl.arm_payment_gateway='$filter_gateway'";
            }
            if (!empty($filter_ptype) && $filter_ptype != '') {
                $filter .= " AND pl.arm_payment_type='$filter_ptype'";
            }
            if (!empty($filter_plans) && $filter_plans != '0') {
                $filter .= " AND pl.arm_plan_id IN ($filter_plans)";
            }
            if (!empty($filter_search) && $filter_search != '') {
                $filter .= " AND (pl.arm_invoice_id LIKE '%".$filter_search."%' OR pl.arm_plan_id LIKE '%".$filter_search."%' OR pl.arm_payment_gateway LIKE '%".$filter_search."%' OR pl.arm_payment_type LIKE '%".$filter_search."%' OR pl.arm_transaction_status LIKE '%".$filter_search."%' OR am.arm_user_login LIKE '%".$filter_search."%')";
            }
            if (!empty($filter_status) && $filter_status != '') {
                $filter .= " AND (pl.arm_transaction_status='".$filter_status."')";
            }
            $get_result_sql = $sql .' '. $filter . ' ' . $order_by_qry . ' '. $phlimit;
            $response_result = $wpdb->get_results($get_result_sql,ARRAY_A);
            
            $before_filter_sql = $wpdb->get_results($sql);

            $before_filter = count($before_filter_sql);

            $total_results = $wpdb->get_results($sql .' '. $filter . ' ' . $order_by_qry);

            $after_filter = count($total_results);
            if(!empty($response_result))
            {
                $ai = 0;
                foreach($response_result as $rc)
                {
                    
                    $plan_detail = '';
                    $rc = (Object) $rc;
                    $arm_is_post_payment = isset($rc->arm_is_post_payment) ? $rc->arm_is_post_payment : 0;
                    $arm_is_gift_payment = isset($rc->arm_is_gift_payment) ? $rc->arm_is_gift_payment : 0;                    $response_data[$ai][0] = $rc->arm_log_id;
                    $arm_invoice_id = $arm_global_settings->arm_manipulate_invoice_id($rc->arm_invoice_id);
                    if($arm_invoice_tax_feature == 1)
                    {
                        $response_data[$ai][1] = "<a class='armhelptip arm_invoice_detail tipso_style' href='javacript:void(0)' data-log_id='" . $rc->arm_log_id . "' title='" . __('View Invoice', 'ARMember') . "'>".$arm_invoice_id."</a>";
                    }
                    else
                    {
                        $response_data[$ai][1] = $arm_invoice_id;
                    }
                    if( $arm_pay_per_post_feature->isPayPerPostFeature && $arm_is_post_payment){
                        $membership_data = "<span class='arm_item_status_plan paid_post'>".__('Paid Post','ARMember')."</span>";
                    }
                    if( $arm_is_gift_payment){
                        $membership_data = "<span class='arm_item_status_plan gift'>".__('Gift','ARMember')."</span>";
                    }
                    if($arm_is_gift_payment)
                    {
                        $gift_id = $rc->arm_plan_id;
                        $gift_sql = "SELECT arm_subscription_plan_name FROM {$ARMember->tbl_arm_subscription_plans} WHERE arm_subscription_plan_id = ".$gift_id;
                        $get_gift_data = $wpdb->get_row($gift_sql);
                        $response_data[$ai][2] = (!empty($get_gift_data->arm_subscription_plan_name)) ? $get_gift_data->arm_subscription_plan_name : '-';
                        if(!empty($get_gift_data->arm_subscription_plan_name))
                        {
                            $response_data[$ai][2].='<br>'.$membership_data;
                        }
                    }
                    else if($arm_is_post_payment)
                    {
                        $post_id = $rc->arm_paid_post_id;
                        $post_sql = "SELECT arm_subscription_plan_name FROM {$ARMember->tbl_arm_subscription_plans} WHERE arm_subscription_plan_post_id  = ".$post_id;
                        $get_post_data = $wpdb->get_row($post_sql);
                        $response_data[$ai][2] = (!empty($get_post_data->arm_subscription_plan_name)) ? $get_post_data->arm_subscription_plan_name : '-';
                        if(!empty($membership_data))
                        {
                            $response_data[$ai][2].='&nbsp;'.$membership_data;
                        }
                    }
                    else
                    {
                        $plan_ID = $rc->arm_plan_id;                       
                        foreach($all_plans as $planData)
                        {
                            $planObj = new ARM_Plan();
                            $planObj->init((object) $planData);
                            $planID = $planData['arm_subscription_plan_id'];
                            if($plan_ID == $planID)
                            {
                                $plan_detail = $planObj->name;
                                break;
                            }
                        }
                        $response_data[$ai][2] = (!empty($plan_detail)) ? $plan_detail : '-';
                        if($arm_pay_per_post_feature->isPayPerPostFeature || is_plugin_active('armembergift/armembergift.php'))
                        {
                            $response_data[$ai][2] .= "&nbsp;<span class='arm_item_status_plan membership'>".__('Plan')."</span>";
                        }
                    }
                    /* if(!empty($plan_data))
                    {
                        $plan_name = esc_html(stripslashes($plan_data['arm_subscription_plan_name']));
                    } */
                    
                    
                    $response_data[$ai][3] = '<a class="arm_openpreview_popup" href="javascript:void(0)" data-id="'.$rc->arm_user_id.'">'.$rc->arm_user_login.'</a>';
                    
                    $log_type = ($rc->arm_payment_gateway == 'bank_transfer') ? 'bt_log' : 'other';
                    $response_data[$ai][4] = date_i18n($date_format, strtotime($rc->arm_payment_date));
                    $all_currencies = $arm_payment_gateways->arm_get_all_currencies();
                    $currency_sym = (isset($all_currencies) && !empty($all_currencies[strtoupper($rc->arm_currency)]))  ? $all_currencies[strtoupper($rc->arm_currency)] : strtoupper($rc->arm_currency);
                    $global_currency_sym_pos = $arm_payment_gateways->arm_currency_symbol_position($global_currency);
                    if($global_currency_sym_pos == 'prefix')
                    {
                        $response_data[$ai][5] = $currency_sym . ' ' .number_format(floatval($rc->arm_amount),$arm_currency_decimal,'.',',') ;
                    }
                    else
                    {
                        $response_data[$ai][5] = number_format(floatval($rc->arm_amount),$arm_currency_decimal,'.',',') .' '. $currency_sym;
                    }
                    $payment_mode = (!empty($rc->arm_payment_mode)) ? $rc->arm_payment_mode : __('Semi Automatic','ARMember');
                    if($payment_mode == 'auto_debit_subscription')
                    {
                        $payment_mode = '<span>'.__('Auto Debit','ARMember').'</span>';
                    }
                    else
                    {
                        $payment_mode = '<span>'.__('Semi Automatic','ARMember') .'</span>';
                    }
                    $payment_gateway = $arm_payment_gateways->arm_gateway_name_by_key($rc->arm_payment_gateway);
                    $payment_type = !empty($rc->arm_payment_mode) ? $rc->arm_payment_mode : 'manual';
                    if($payment_gateway != 'manual')
                    {
                        $payment_types = ($payment_type != 'auto_debit_subscription') ? __('Semi Automatic','ARMember') : __('Auto Debit','ARMember')  ;
                        $class = ($payment_type != 'auto_debit_subscription') ? 'arm_semi_auto' : 'arm_auto';
                        $response_data[$ai][6] = $payment_gateway." <br/><span class='arm_payment_types ".$class."'>".$payment_types."</span>";                    
                    }
                    else
                    {
                        $response_data[$ai][6] = $payment_gateway;    
                    }
                    $arm_transaction_status = $rc->arm_transaction_status;
                    switch ($arm_transaction_status) {
                        case '0':
                            $arm_transaction_status = 'pending';
                            break;
                        case '1':
                            $arm_transaction_status = 'success';
                            break;
                        case '2':
                            $arm_transaction_status = 'canceled';
                            break;
                        default:
                            $arm_transaction_status = $rc->arm_transaction_status;
                            break;
                    }
                    $response_data[$ai][7] =  $arm_transaction->arm_get_transaction_status_text($arm_transaction_status);
                    $transactionID = $rc->arm_log_id;   
                    $gridAction = "<div class='arm_grid_action_btn_container'>";
                    if ($rc->arm_payment_gateway == 'bank_transfer' && $arm_transaction_status == 'pending') {
                    	$changeStatusFun = 'ChangeStatus(' . $transactionID .',1);';
                    	$chagneStatusFun2 = 'ChangeStatus(' . $transactionID . ',2);';
                    	$armbPopupArg = 'change_transaction_status_message';
                    	if( $arm_is_post_payment ){
                    		$changeStatusFun = 'ArmPPChangeStatus(' . $transactionID .',1);';
                    		$chagneStatusFun2 = 'ArmPPChangeStatus(' . $transactionID . ',2);';
                    		$armbPopupArg = 'change_pp_transaction_status_message';
                    	}
                    	else if( $arm_is_gift_payment ){
                    		$changeStatusFun = 'ArmGPChangeStatus(' . $transactionID .',1);';
                    		$chagneStatusFun2 = 'ArmGPChangeStatus(' . $transactionID . ',2);';
                    		$armbPopupArg = 'change_gp_transaction_status_message';
                    	}

                        $gridAction .= "<a class='armhelptip arm_change_btlog_status' href='javascript:void(0)' onclick=\"{$changeStatusFun}armBpopup('{$armbPopupArg}');\" data-status='1' data-log_id='" . $transactionID . "' title='" . __('Approve', 'ARMember') . "'><img src='" . MEMBERSHIP_IMAGES_URL . "/grid_approved.png' onmouseover=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/grid_approved_hover.png';\" onmouseout=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/grid_approved.png';\" /></a>";
                        $gridAction .= "<a class='armhelptip arm_change_btlog_status' href='javascript:void(0)' onclick=\"{$chagneStatusFun2}armBpopup('{$armbPopupArg}');\" data-status='2' data-log_id='" . $transactionID . "' title='" . __('Reject', 'ARMember') . "'><img src='" . MEMBERSHIP_IMAGES_URL . "/grid_denied.png' onmouseover=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/grid_denied_hover.png';\" onmouseout=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/grid_denied.png';\" /></a>";
                    } 
                    if( $arm_transaction_status == 'success' && $arm_invoice_tax_feature == 1 ) {
                    	$gridAction .= "<a class='armhelptip arm_invoice_detail' href='javascript:void(0)' data-log_type='" . $log_type . "' data-log_id='" . $transactionID . "' title='" . __('View Invoice', 'ARMember') . "'><img src='" . MEMBERSHIP_IMAGES_URL . "/invoice_icon.png' onmouseover=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/invoice_icon_hover.png';\" onmouseout=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/invoice_icon.png';\" /></a>";
                    }
                    $gridAction .= "<a class='armhelptip arm_preview_log_detail' href='javascript:void(0)' data-log_type='" . $log_type . "' data-log_id='" . $transactionID . "' data-trxn_status='".$arm_transaction_status."' title='" . __('View Detail', 'ARMember') . "'><img src='" . MEMBERSHIP_IMAGES_URL . "/grid_preview.png' onmouseover=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/grid_preview_hover.png';\" onmouseout=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/grid_preview.png';\" /></a>";
                    $gridAction .= "<a href='javascript:void(0)' data-log_type='" . $log_type . "' data-delete_log_id='" . $transactionID . "' data-trxn_status='".$arm_transaction_status."' onclick='showConfirmBoxCallback({$transactionID});'><img src='" . MEMBERSHIP_IMAGES_URL . "/grid_delete.png' class='armhelptip' title='" . __('Delete', 'ARMember') . "' onmouseover=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/grid_delete_hover.png';\" onmouseout=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/grid_delete.png';\" /></a>";
                    $arm_transaction_del_cls = 'arm_transaction_delete_btn';
                    if( $arm_is_post_payment ){
                    	$arm_transaction_del_cls .= ' arm_pp_transaction_delete_btn';
                    }
                    else if( $arm_is_gift_payment ){
                    	$arm_transaction_del_cls .= ' arm_gp_transaction_delete_btn';
                    }
                    $gridAction .= $arm_global_settings->arm_get_confirm_box($transactionID, __("Are you sure you want to delete this transaction?", 'ARMember'), $arm_transaction_del_cls, $log_type);
                    $gridAction .= "</div>";
                    $response_data[$ai][8] = $gridAction;
                    $ai++;
                }
            }
            $sEcho = isset($_REQUEST['sEcho']) ? intval($_REQUEST['sEcho']) : intval(10);
            $response = array(
                'sColumns' => implode(',', $grid_columns),
                'sEcho' => $sEcho,
                'iTotalRecords' => $before_filter, // Before Filtered Records
                'iTotalDisplayRecords' => $after_filter, // After Filter Records
                'aaData' => $response_data,
            );
            echo json_encode($response);
            die();
        }
        function arm_fetch_subscription_data() {
            global $wpdb, $ARMember, $arm_slugs, $arm_members_class, $arm_member_forms, $arm_global_settings, $arm_subscription_plans, $arm_payment_gateways, $is_multiple_membership_feature, $arm_capabilities_global, $arm_pay_per_post_feature,$arm_transaction;

            $ARMember->arm_check_user_cap($arm_capabilities_global['arm_manage_subscriptions'], '1');
            $date_format = $arm_global_settings->arm_get_wp_date_format();
            $user_roles = get_editable_roles();
            $nowDate = current_time('mysql');
            $is_gift_enabled = is_plugin_active('armembergift/armembergift.php');
            $is_paid_post_enabled = $arm_pay_per_post_feature->isPayPerPostFeature;

            $global_currency = $arm_payment_gateways->arm_get_global_currency();
			$general_settings = isset($arm_global_settings->global_settings) ? $arm_global_settings->global_settings : array();
			$arm_currency_decimal = isset($general_settings['arm_currency_decimal_digit']) ? $general_settings['arm_currency_decimal_digit'] : 2;

            $response_data = array();

            $filter_ptype = isset($_REQUEST['payment_type']) ? $_REQUEST['payment_type'] : '';
            $filter_search = isset($_REQUEST['sSearch']) ? $_REQUEST['sSearch'] : '';

            $all_plans = $arm_subscription_plans->arm_get_all_subscription_plans();
            if(!empty($_POST['data']))
            {
                $_REQUEST = $_POST = json_decode(stripslashes_deep($_REQUEST['data']),true);
            }
            $sql = '';
            $filter = '';
            $total_results = 0;
            $response_result = array();
            
            $filter_plans = (!empty($_REQUEST['arm_subs_filter']) && $_REQUEST['arm_subs_filter'] != '') ? $_REQUEST['arm_subs_filter'] : '';
            $filter_status_id = (!empty($_REQUEST['plan_status']) && $_REQUEST['plan_status'] != 0) ? $_REQUEST['plan_status'] : '';
            $filter_gateway = (!empty($_REQUEST['payment_gateway']) && $_REQUEST['payment_gateway'] != '0') ? $_REQUEST['payment_gateway'] : '';
            $filter_plan_type = (!empty($_REQUEST['filter_plan_type']) && $_REQUEST['filter_plan_type'] != '') ? $_REQUEST['filter_plan_type'] : '';
            $filter_tab = (!empty($_REQUEST['selected_tab']) && $_REQUEST['selected_tab'] != '') ? $_REQUEST['selected_tab'] : 'activity';
            
            $sorting_ord = isset($_REQUEST['sSortDir_0']) ? strtoupper($_REQUEST['sSortDir_0']) : 'DESC';
            $sorting_col = (isset($_REQUEST['iSortCol_0']) && $_REQUEST['iSortCol_0'] > 0) ? $_REQUEST['iSortCol_0'] : 1;

            $offset = isset($_REQUEST['iDisplayStart']) ? $_REQUEST['iDisplayStart'] : 0;
            $limit = isset($_REQUEST['iDisplayLength']) ? $_REQUEST['iDisplayLength'] : 10;
            $phlimit = " LIMIT {$offset},{$limit}";
            
            $response_data = array();
            $grid_columns = array(
                'arm_activity_id' => __('ID', 'ARMember'),
                'arm_item_id' => __('Membership', 'ARMember'),
                'arm_user_login' => __('Username', 'ARMember'),
                'arm_date_recorded' => __('Start Date', 'ARMember'),
                'arm_next_cycle_date' => __('Expire/Next Renewal', 'ARMember'),
                'arm_amount' => __('Amount Type', 'ARMember'),
                'arm_payment_type' => __('Payment Type', 'ARMember'),
                'arm_transactions' => __('Transaction', 'ARMember'),
                'arm_plan_status' => __('Status', 'ARMember'),
            );
            $grid_columns['action_btn'] = '';    
            $data_columns = array();
            $n = 1;
            foreach ($grid_columns as $key => $value) {
                $data_columns[$n]['data'] = $key;
                $n++;
            }
            unset($n);
            $sql = 'SELECT act.arm_activity_id,act.arm_user_id,am.arm_user_login,act.arm_content,act.arm_item_id,act.arm_paid_post_id,act.arm_gift_plan_id,act.arm_date_recorded FROM '.$ARMember->tbl_arm_activity.' act LEFT JOIN '.$ARMember->tbl_arm_members.' am ON act.arm_user_id = am.arm_user_id WHERE 1=1 AND act.arm_user_id !=0 AND act.arm_action = "new_subscription"';
            
            $orderby = $data_columns[(intval($sorting_col))]['data'];

            $order_by_qry = "ORDER BY " . $orderby . " " . $sorting_ord ;
            if(!empty($filter_gateway))
            {
                $filter_gateway = '"'.$filter_gateway.'"';
                $filter .= "AND act.arm_content LIKE '%".$filter_gateway."%' ";
            }
            if(!empty($filter_ptype))
            {
                $filter_data = '%s:17:"plan_payment_type";s:8:"'.$filter_ptype.'"%';
                if($filter_ptype == 'subscription')
                {
                    $filter_data = '%s:17:"plan_payment_type";s:12:"'.$filter_ptype.'"%';
                }
                $filter .= "AND act.arm_content LIKE '".$filter_data."'";
            }
            if(!empty($filter_search))
            {
                $filter .= 'AND (am.arm_user_login LIKE "%'.$filter_search.'%") ';
            }
            if (!empty($filter_plans) && $filter_plans != '0') {
                $filter .= " AND `arm_item_id` IN ($filter_plans) ";
            }
            if(!empty($filter_status_id))
            {
                $user_ids = array();
                $plan_ids = array();
                $filter_sql = $sql;
                $filter_response_result = $wpdb->get_results($filter_sql);
                if(!empty($filter_response_result))
                {
                    foreach($filter_response_result as $rc)
                    {
                        $rc = (object) $rc;
                        $user_plan_detail = get_user_meta($rc->arm_user_id, 'arm_user_plan_'.$rc->arm_item_id, true);
                        $get_activity_data = maybe_unserialize($rc->arm_content);
                        $start_plan_date = $get_activity_data['start'];
                        $plan_status = $this->get_return_status_data($rc->arm_user_id,$rc->arm_item_id,$user_plan_detail,$start_plan_date);
                        $suspended_plan_detail = get_user_meta($rc->arm_user_id, 'arm_user_suspended_plan_ids', true);
                        
                        if(!empty($plan_status['status']) && $plan_status['status'] == 'suspended' && $filter_status_id == '3')
                        {
                            array_push($user_ids,$rc->arm_activity_id);
                        }
                        else if( !empty($plan_status['status']) && $plan_status['status'] == 'canceled' && $filter_status_id == '4')
                        {
                            array_push($user_ids,$rc->arm_activity_id);
                        }
                        else if( !empty($plan_status['status']) && $plan_status['status'] == 'expired' && $filter_status_id == '2')
                        {
                            array_push($user_ids,$rc->arm_activity_id);
                        }
                        else if(!empty($plan_status['status']) && $plan_status['status'] == 'active' &&  $filter_status_id == '1' && (empty($suspended_plan_detail) || !in_array($rc->arm_item_id,$suspended_plan_detail)))
                        {
                            array_push($user_ids,$rc->arm_activity_id);
                        }
                    }
                }
                $user_ids = implode(',',$user_ids);
                $filter .= " AND act.arm_activity_id IN ($user_ids)";
            }
            
            $before_filter_total_results = $wpdb->get_results($sql);
            
            $before_filter = count($before_filter_total_results);

            $get_result_sql = $sql .' '. $filter . ' '.$order_by_qry.' '. $phlimit;

            $response_result = $wpdb->get_results($get_result_sql);

            $total_results = $wpdb->get_results($sql .' '. $filter . ' '.$order_by_qry);
           
            $after_filter = count($total_results);

            if(!empty($response_result))
            {
                $ai = 0;
                foreach($response_result as $rc)
                {
                    $rc = (object) $rc;
                    $activity_id = $rc->arm_activity_id;
                    $user_id = $rc->arm_user_id;
                    $plan_id = $rc->arm_item_id;
                    $plan_name = '';
                    $is_paid_post = (!empty($rc->arm_paid_post_id)) ? 1 : 0;
                    $is_gift_plan = (!empty($rc->arm_gift_id)) ? 1 : 0;
                    $response_data[$ai][1] = $rc->arm_activity_id;
                    $get_activity_data = maybe_unserialize($rc->arm_content);
                    $membership_data = "<span class='arm_item_status_plan paid_post'>".__('Plan','ARMember')."</span>";
                    if( $arm_pay_per_post_feature->isPayPerPostFeature && $is_paid_post){
                        $membership_data = "<span class='arm_item_status_plan paid_post'>".__('Paid Post','ARMember')."</span>";
                    }
                    if( $is_gift_plan){
                        $membership_data = "<span class='arm_item_status_plan gift'>".__('Gift','ARMember')."</span>";
                    }
                    if(!empty($get_activity_data))
                    {
                        $grace_period_data = $plan_detail = $membership_start = '';
                        $plan_text = htmlentities($get_activity_data['plan_text']);
                        $plan_details = explode('&lt;br/&gt;',$plan_text);
                        
                        $plan_detail = (!empty($plan_details[1])) ? $plan_detail = strip_tags(html_entity_decode($plan_details[1])) : $plan_details[0] ;
                        $user_plan_detail = get_user_meta($user_id, 'arm_user_plan_'.$rc->arm_item_id, true);
                        $membership_start = (!empty($user_plan_detail['arm_start_plan'])) ? $user_plan_detail['arm_start_plan'] : 0;           
                        if(!empty($user_plan_detail['arm_is_user_in_grace']) && $user_plan_detail['arm_is_user_in_grace'] == 1)
                        {
                            $grace_period_data = "<span class='arm_item_status_plan grace'>".__('Grace Expiration','ARMember').": ". date_i18n($date_format, $user_plan_detail['arm_grace_period_end'])."</span>";
                        }
                        $start_plan_date = $get_activity_data['start'];
                        if(!empty($user_plan_detail['arm_current_plan_detail']) && $user_plan_detail['arm_current_plan_detail']['arm_subscription_plan_type'] == 'recurring')
                        {
                            $arm_subscription_plans_expire = date_i18n($date_format, $user_plan_detail['arm_next_due_payment']);
                        }
                        else
                        {
                            $arm_subscription_plans_expire = !empty($user_plan_detail['arm_expire_plan']) ? date_i18n($date_format, $user_plan_detail['arm_expire_plan']) : '-';
                        }
                        $suspended_plan_detail = get_user_meta($user_id, 'arm_user_suspended_plan_ids', true);
                        $plan_status = $this->get_return_status_data($user_id,$rc->arm_item_id,$user_plan_detail,$start_plan_date);
                        $status = !empty($plan_status['status']) ? $plan_status['status'] : '';
                        $canceled_date = !empty($plan_status['canceled_date']) ? $plan_status['canceled_date'] : '';
                        if(!empty($plan_status['status']) && $plan_status['status'] == 'suspended')
                        {
                            $status = 'suspended';
                            $response_data[$ai][9] = '<span class="arm_item_status_plan cancelled">'.__('Suspended','ARMember').'</span>';
                        }
                        else if(!empty($plan_status['status']) &&  $plan_status['status'] == 'canceled')
                        {
                            $status = 'canceled';
                            $arm_subscription_plans_expire = '-';
                            $response_data[$ai][9] = '<span class="arm_item_status_plan cancelled">'.__('Canceled','ARMember').'</span>';
                        }
                        else if( !empty($plan_status['status']) && $plan_status['status'] == 'expired')
                        {
                            $status = 'expired';
                            $arm_subscription_plans_expire = '-';
                            $response_data[$ai][9] = '<span class="arm_item_status_plan expired">'.__('Expired','ARMember').'</span>';
                        }
                        else if( !empty($plan_status['status']) && $plan_status['status'] == 'active')
                        {
                            $status = 'active';
                            $response_data[$ai][9] ='<span class="arm_item_status_plan active">'.__('Active','ARMember').'</span>';
                        }
                        else{
                            $arm_subscription_plans_expire = '-';
                            $status ='';
                            $response_data[$ai][9] ='';
                        }
                        $plan_name = $get_activity_data['plan_name'];
                        if($is_gift_enabled || $is_paid_post_enabled)
                        {
                            $response_data[$ai][2] = $get_activity_data['plan_name']." &nbsp; " .$membership_data. "<br/><span class='arm_plan_style' style='margin-right:10px'>".$plan_detail."</span><br/>".$grace_period_data;
                        }
                        else
                        {
                            $response_data[$ai][2] = $get_activity_data['plan_name'] . "<br/><span class='arm_plan_style'>".$plan_detail."</span><br/>".$grace_period_data;
                        }
                        $response_data[$ai][5] = $arm_subscription_plans_expire;
                        $response_data[$ai][6] = number_format(floatval($get_activity_data['plan_amount']),$arm_currency_decimal,'.',',');
                        $payment_type = !empty($user_plan_detail['arm_payment_mode']) ? $user_plan_detail['arm_payment_mode'] : 'manual';
                        
                    }

                    $response_data[$ai][3] = '<a class="arm_openpreview_popup" href="javascript:void(0)" data-id="'.$user_id.'">'.$rc->arm_user_login.'</a>';
                    $start_plan_date = $get_activity_data['start'];
                    $response_data[$ai][4] = date_i18n($date_format, $start_plan_date);
                    $transaction_started_date = date('Y-m-d H:i:s', ($start_plan_date - 120));
                    $payment_gateway = $get_activity_data['gateway'];
                    if($payment_gateway == 'manual')
                    {
                        $transaction_started_date = date('Y-m-d 00:00:00', $start_plan_date);
                    }
                    
                    if(!empty($canceled_date))
                    {
                        $get_last_transaction_sql = "SELECT * FROM ".$ARMember->tbl_arm_payment_log." WHERE arm_user_id=".$user_id." AND arm_plan_id=".$rc->arm_item_id." AND arm_created_date BETWEEN '".$transaction_started_date."' AND '".$canceled_date."'  ORDER BY arm_log_id DESC";
                    }
                    else
                    {
                        $get_last_transaction_sql = "SELECT * FROM ".$ARMember->tbl_arm_payment_log." WHERE arm_user_id=".$user_id." AND arm_plan_id=".$rc->arm_item_id." AND arm_created_date >= '".$transaction_started_date."' ORDER BY arm_log_id DESC";
                    }
                    
                    $get_transaction_sql = $wpdb->get_results($get_last_transaction_sql,ARRAY_A);
                    $transaction_count = 0;
                    if(!empty($get_transaction_sql))
                    {
                        $total_trans = count($get_transaction_sql);
                        
                        $payment_gateway_text = $arm_payment_gateways->arm_gateway_name_by_key($payment_gateway);
                        if($payment_gateway != 'manual')
                        {
                            $payment_types = ($payment_type != 'auto_debit_subscription') ? __('Semi Automatic','ARMember') : __('Auto Debit','ARMember')  ;
                            $class = ($payment_type != 'auto_debit_subscription') ? 'arm_semi_auto' : 'arm_auto';
                            $response_data[$ai][7] = $payment_gateway_text." <br/><span class='arm_payment_types ".$class."'>".$payment_types."</span>";                    
                        }
                        else
                        {
                            $response_data[$ai][7] = $payment_gateway_text;  
                        }
                        $response_data[$ai][8] = $total_trans;
                        $transaction_count = $total_trans;
                    }
                    else
                    {
                        $response_data[$ai][7] = __('Manual','ARMember');
                        $response_data[$ai][8] ='0';
                        $transaction_count = 0;
                    }
                    $activityID = $rc->arm_activity_id;   
                    if($transaction_count > 0)
                    {
                        $response_data[$ai][0] = "<div class='arm_show_user_more_transactions' id='arm_show_user_more_transaction_" . $activityID . "' data-id='" . $activityID . "'></div>";
                    }
                    else
                    {
                        $response_data[$ai][0] = "";
                    }
                    $gridAction ='';
                    $gridAction .= "<div class='arm_grid_action_btn_container'>";
                    if($status == 'active')
                    {
                        $allow_refund = apply_filters('arm_display_refund_button_from_outside', false, $payment_gateway);
                        if(!in_array($payment_gateway,array('manual','bank_transfer')) && $allow_refund)
                        {
                            $gridAction .= "<a href='javascript:void(0)' data-refund_activity_id='" . $activityID . "' onclick='showConfirmBoxCallback_refund({$activityID});'><img src='" . MEMBERSHIP_IMAGES_URL . "/arm-refund-icon.png' class='armhelptip' title='" . __('Refund', 'ARMember') . "' onmouseover=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/arm-refund-icon-hover.png';\" onmouseout=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/arm-refund-icon.png';\" style='vertical-align:middle' /></a>";
    
                            $confirmBox = "<div class='arm_confirm_box arm_confirm_box_refund arm_confirm_box_{$activityID}' id='arm_confirm_box_refund_{$activityID}'>";
                                $confirmBox .='<form id="#arm_refund_form_'.$activityID.'" class="arm_refund_form" >';
                                $confirmBox .= "<input type='hidden' name='arm_refund_data[activity_id]' id='arm_activity_id' value='".$activity_id."'><input type='hidden' id='arm_default_refund_amount' value='".$get_activity_data['plan_amount']."' name='arm_refund_data[arm_default_refund_amount]'>";
                                $confirmBox .= "<div class='arm_confirm_box_body' >";
                                $confirmBox .= "<div class='arm_confirm_box_arrow'></div>";
                                $confirmBox .= "<div class='arm_confirm_box_label'><b>" . __("Refund Payment", 'ARMember') . "</b></div>";
                                $confirmBox .= "<div class='arm_confirm_box_btn_container' style='display:none'>";
                                $confirmBox .=" <div class='arm_confirm_box_label' style='margin-top: 10px'>".__('Refund Type','ARMember')." </div>";
                                $confirmBox .='<div class="arm_refund_mode_container" id="arm_refund_mode_container">
                                <input id="arm_refund_mode_full_'.$activityID.'" class="arm_refund_mode_radio arm_iradio" type="radio" value="full" name="arm_refund_data[arm_refund_mode]" checked="checked">
                                <label class="arm_confirm_box_label" for="arm_refund_mode_full_'.$activityID.'" style="font-size: 16px;font-weight: normal;">'. __('Full', 'ARMember').'</label>
                                <input id="arm_refund_mode_partial_'.$activityID.'" class="arm_refund_mode_radio arm_iradio" type="radio" value="partial" name="arm_refund_data[arm_refund_mode]">
                                <label class="arm_confirm_box_label" for="arm_refund_mode_partial_'.$activityID.'" style="font-size: 16px;font-weight: normal;">'. __('partial', 'ARMember').'</label>
                                </div>';
                                $global_currency = $arm_payment_gateways->arm_get_global_currency();
                                $all_currencies = $arm_payment_gateways->arm_get_all_currencies();
                                $currency_sym = (isset($all_currencies) && !empty($all_currencies[strtoupper($global_currency)]))  ? $all_currencies[strtoupper($global_currency)] : strtoupper($global_currency);
                                $confirmBox .='<div class="arm_refund_amount_container hidden_section" id="arm_refund_amount_container" style="margin-top: 10px">';
                                $confirmBox .=" <div class='arm_confirm_box_label'>".__('Refund amount','ARMember')."(".$currency_sym.")";
                                $confirmBox .='<input type="text" id="arm_refund_amount" value="" placeholder="'.__('Refund amount','ARMember').'" name="arm_refund_data[arm_refund_amount]" style="width:100%;"></div>';
                                $confirmBox .='</div>';
                                $confirmBox .=" <div class='arm_confirm_box_label' style='margin-top: 10px'>".__('Refund Reason','ARMember')." </div>";
                                $confirmBox .='<div class="arm_refund_reason_container" id="arm_refund_reason_container" style="height:80px;">
                                <textarea class="arm_codemirror_field" name="arm_refund_data[arm_refund_reason]" pleaceholder="'.__('Refund Reason','ARMember').'" id ="arm_refund_reason_'.$activityID.'" rows="3" style="height: 70px;min-height: 70px;resize:none !important;width:100%;"></textarea>
                                </div>';
    
                                $arm_member_refund_btn_class = 'arm_member_plan_refund_btn' ;
    
                                $confirmBox .= "<button type='button' class='arm_confirm_box_btn armok ".$arm_member_refund_btn_class."' data-item_id='{$activityID}'>" . __('Refund', 'ARMember') . "</button>";
                                
                                $confirmBox .= "<button type='button' class='arm_confirm_box_btn armcancel' onclick='hideConfirmBoxCallback();'>" . __('Cancel', 'ARMember') . "</button>";
                                $confirmBox .= "</div>";
                                $confirmBox .= "</form>";
                                $confirmBox .= "</div>";
                                $confirmBox .= "</div>";
    
                            $gridAction .= $confirmBox;
                        }

                        $gridAction .= "<a href='javascript:void(0)' data-cancel_activity_type='" . $status . "'  data-cancel_activity_id='" . $activityID . "' onclick='showConfirmBoxCallback({$activityID});'><img src='" . MEMBERSHIP_IMAGES_URL . "/grid_denied.png' class='armhelptip' title='" . __('Cancel', 'ARMember') . "' onmouseover=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/grid_denied_hover.png';\" onmouseout=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/grid_denied.png';\" /></a>";
                        $arm_transaction_del_cls = 'arm_activity_delete_btn';
                        $gridAction .= $arm_global_settings->arm_get_confirm_box($activityID, __("Are you sure you want to cancel this subscription  ?", 'ARMember'), $arm_transaction_del_cls);

                    }
                    if($status == 'suspended')
                    {
                        $gridAction .= "<a href='javascript:void(0)' data-activation_id='" . $activityID . "' data-plan_id='" . $plan_id . "' onclick='showConfirmBoxCallback_activation({$activityID});'><img src='" . MEMBERSHIP_IMAGES_URL . "/arm-active-plan.png' class='armhelptip' title='" . __('Activate Plan', 'ARMember') . "' onmouseover=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/arm-active-plan-hover.png';\" onmouseout=\"this.src='" . MEMBERSHIP_IMAGES_URL . "/arm-active-plan.png';\" style='vertical-align:middle' /></a>";

                        $arm_plan_is_suspended .= "<div class='arm_confirm_box arm_confirm_box_activate_{$activityID}' id='arm_confirm_box_activate_{$activityID}' style='right: -5px;'>";
                        $arm_plan_is_suspended .= "<div class='arm_confirm_box_body'>";
                        $arm_plan_is_suspended .= "<div class='arm_confirm_box_arrow'></div>";
                        $arm_plan_is_suspended .= "<div class='arm_confirm_box_text'>" . __("Are you sure you want to activate " . $plan_name . " plan for this user?", 'ARMember') . "</div>";
                        $arm_plan_is_suspended .= "<div class='arm_confirm_box_btn_container'>";
                        $arm_plan_is_suspended .= "<button type='button' class='arm_confirm_box_btn armok arm_plan_activation_change' data-item_id='{$activityID}'>" . __('Activate', 'ARMember') . "</button>";
                        $arm_plan_is_suspended .= "<button type='button' class='arm_confirm_box_btn armcancel' onclick='hideConfirmBoxCallback();'>" . __('Cancel', 'ARMember') . "</button>";
                        $arm_plan_is_suspended .= "</div>";
                        $arm_plan_is_suspended .= "</div>";
                        $arm_plan_is_suspended .= "</div></div>";

                        $gridAction .= $arm_plan_is_suspended;
                    }
                    $gridAction .= "</div>";
                    $response_data[$ai][10] = $gridAction;
                    $ai++;
                }
                // exit;
            }
            $sEcho = isset($_REQUEST['sEcho']) ? intval($_REQUEST['sEcho']) : intval(10);
            $response = array(
                'sColumns' => implode(',', $grid_columns),
                'sEcho' => $sEcho,
                'iTotalRecords' => $before_filter, // Before Filtered Records
                'iTotalDisplayRecords' => $after_filter, // After Filter Records
                'aaData' => $response_data,
            );
            echo json_encode($response);
            die();
        
        }
        function get_return_status_data($user_id,$plan_id,$user_plan_detail,$start_plan_date)
        {
            global $wp,$wpdb,$ARMember;
            $end_date = '';
            
            $suspended_plan_detail = get_user_meta($user_id, 'arm_user_suspended_plan_ids', true);
            $active_plan_detail = get_user_meta($user_id, 'arm_user_plan_ids', true);
            if(!empty($user_plan_detail['arm_next_due_payment']))
            {
                $end_date = $user_plan_detail['arm_next_due_payment'];
            }
            else
            {
                $end_date = !empty($user_plan_detail['arm_expire_plan']) ? $user_plan_detail['arm_expire_plan'] : '';
            }
            $sql_act = 'SELECT arm_action,arm_content,arm_date_recorded FROM '.$ARMember->tbl_arm_activity.' WHERE arm_user_id='.$user_id.' AND arm_item_id = '.$plan_id .' AND (arm_action="cancel_subscription" OR arm_action="eot")';
            $get_activity_status = $wpdb->get_results($sql_act);
            $retun_data = array();
            if(!empty($get_activity_status))
            {
                
                foreach($get_activity_status as $ract)
                {
                    $get_cancel_eot_activity_data = maybe_unserialize($ract->arm_content);
                    $plan_started_date = $get_cancel_eot_activity_data['start'];
                    
                    if( $start_plan_date == $plan_started_date)
                    {
                        if($ract->arm_action == 'cancel_subscription')
                        {
                            
                            $retun_data = array('status'=>'canceled','canceled_date'=>$ract->arm_date_recorded);
                            break;
                        }
                        else if($ract->arm_action == 'eot')
                        {
                            $retun_data = array('status'=>'expired','canceled_date'=>$ract->arm_date_recorded);
                            break;
                        }
                    }
                    else
                    {
                        if(!empty($active_plan_detail) && in_array($plan_id,$active_plan_detail))
                        {
                            $retun_data = array('status'=>'active','canceled_date'=>'');
                            break;
                        }
                        else {
                            $retun_data = array('status'=>'','canceled_date'=>'');
                        }
                    }
                    
                }
            }
            else
            {
                if(!empty($suspended_plan_detail) && in_array($plan_id,$suspended_plan_detail))
                {
                    $retun_data = array('status'=>'suspended','canceled_date'=>'');
                }
                else
                {
                    if(!empty($active_plan_detail) && in_array($plan_id,$active_plan_detail))
                    {
                        $retun_data = array('status'=>'active','canceled_date'=>'');
                    }
                    else {
                        $retun_data = array('status'=>'','canceled_date'=>'');
                    }

                }

            }
            return $retun_data;
        }
        function arm_cancel_subscription_data()
        {
            global $wp,$wpdb,$ARMember,$arm_subscription_plans;
            $activity_id = $_POST['activity_id'];

            $sql_act = 'SELECT * FROM '.$ARMember->tbl_arm_activity.' WHERE arm_activity_id='.$activity_id;
            $get_activity_status = $wpdb->get_row($sql_act,ARRAY_A);

            
            $response ='';
            if($get_activity_status['arm_action'] == 'new_subscription')
            {
                //check membership plan has selected "DO NOT CANCEL UNTIL PLAN EXPIRES" option
                unset($get_activity_status['arm_activity_id']);
                $get_activity_status['arm_action'] = 'cancel_subscription';
                $get_activity_status['arm_date_recorded'] = current_time('mysql');
                $user_id = $get_activity_status['arm_user_id'];

                $plan_id = $get_activity_status['arm_item_id'];

                $update = $arm_subscription_plans->arm_ajax_stop_user_subscription($user_id,$plan_id);
                if($update['type']=='success')
                {
                    $response = array('type' => 'success', 'message' => __('Subscription plan has been canceled successfully', 'ARMember'));
                }
                else
                {
                    $response = array('type' => 'error', 'message' => __('Something went wrong please try again', 'ARMember'));
                }
            }
            echo json_encode($response);
            die;
        }

        function arm_refund_subscription_action()
        {
            global $wp,$wpdb,$ARMember,$arm_capabilities_global,$arm_subscription_plans,$arm_members_class;
            $ARMember->arm_check_user_cap($arm_capabilities_global['arm_manage_subscriptions'], '1');

            $arm_refund_data = $_POST['arm_refund_data'];
            $activity_id = $arm_refund_data['activity_id'];
            $refund_reason = $arm_refund_data['refund_reason'];
            $sql_act = 'SELECT `arm_user_id`,`arm_item_id` FROM '.$ARMember->tbl_arm_activity.' WHERE arm_activity_id='.$activity_id;
            $get_result_sql = $wpdb->get_row($sql_act,ARRAY_A);
            $user_id = $get_result_sql['arm_user_id'];
            $plan_id = $get_result_sql['arm_item_id'];
            $get_last_transaction_sql = "SELECT arm_transaction_id,arm_payment_gateway FROM ".$ARMember->tbl_arm_payment_log." WHERE arm_user_id=".$user_id." AND arm_plan_id=".$plan_id." ORDER BY arm_log_id DESC LIMIT 1";
            $get_transaction_detail_sql = $wpdb->get_row($get_last_transaction_sql,ARRAY_A);
            $arm_payment_gateway = $get_transaction_detail_sql['arm_payment_gateway'];
            $response = array();
            if(!in_array($arm_payment_gateway,array('bank_transfer','manual')))
            {
                $arm_transaction_id = $get_transaction_detail_sql['arm_transaction_id'];
                $arm_refund_data['arm_transaction_id'] = $arm_transaction_id;
                $response = apply_filters('arm_refund_payment_subscription_'.$arm_payment_gateway,$arm_refund_data,$arm_payment_gateway);
                if(!empty($response) && $response['type'] == 'success')
                {
                    $post_data=array('arm_action'=>'delete','user_id'=>$user_id,'plan_id'=>$plan_id);
                    $is_removed = $arm_members_class->arm_user_plan_action($post_data,true);
                    $refunded_amount = ($arm_refund_data['arm_refund_mode'] == 'full') ? $arm_refund_data['arm_default_refund_amount'] : $arm_refund_data['arm_refund_amount'] ;
                    $refunded_data=array(
                        'refund_activity_id'=>$activity_id,
                        'refund_type'=>$arm_refund_data['arm_refund_mode'],
                        'refund_amount'=>$refunded_amount,
                        'refund_reason'=>$arm_refund_data['arm_refund_reason']
                    );
                    $get_last_canceled_id = 'SELECT arm_log_id,arm_extra_vars FROM '.$ARMember->tbl_arm_payment_log.' WHERE arm_user_id='.$user_id.' AND arm_plan_id='.$plan_id.' AND arm_transaction_status="canceled" LIMIT 0,1';
                    $get_last_cenceled_sql = $wpdb->get_row($get_last_canceled_id,ARRAY_A);
                    if(!empty($get_last_cenceled_sql['arm_extra_vars']))
                    {
                        $get_extra_vars = maybe_unserialize($get_last_cenceled_sql['arm_extra_vars']);
                        $refunded_data = array_push($get_extra_vars,$refunded_data);
                    }
                    $wpdb->update($ARMember->tbl_arm_payment_log, array('arm_extra_vars' => maybe_serialize($refunded_data)), array('arm_log_id' => $get_last_cenceled_sql['arm_log_id']));
                }
                else
                {
                    $response = array('type'=>'error','msg'=>$response['msg']);    
                }
            }else
            {
                $response = array('type'=>'error','msg'=>__('Bank Transfer and Manual does not support refund','ARMember'));    
            }
            echo json_encode($response);
            die;
        }
    }
}
global $arm_subscription_class;
$arm_subscription_class = new ARM_subsctriptions();